<ng-container
*ngFor="let node of bodyMap"
[ngTemplateOutlet]="nodeSwitch"
[ngTemplateOutletContext]="{ node: node }">
</ng-container>

<ng-template #nodeSwitch let-node="node">
    <ng-container *ngIf="node.tagName">
        <ng-container [ngSwitch]="node.tagName">

            <ng-container *ngSwitchCase="'H2'">
                <h2>
                    <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                </h2>
            </ng-container>

            <ng-container *ngSwitchCase="'H3'">
                <h3>
                    <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                </h3>
            </ng-container>

            <ng-container *ngSwitchCase="'BR'">
                <br>
            </ng-container>

            <ng-container *ngSwitchCase="'P'">
                <p>
                    <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                </p>
            </ng-container>

            <ng-container *ngSwitchCase="'UL'">
                <ul>
                    <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                </ul>
            </ng-container>

            <ng-container *ngSwitchCase="'OL'">
                <ol>
                    <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                </ol>
            </ng-container>

            <ng-container *ngSwitchCase="'LI'">
                <li>
                    <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                </li>
            </ng-container>

            <ng-container *ngSwitchCase="'DIV'">
                <div>
                    <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                </div>
            </ng-container>

            <ng-container *ngSwitchCase="'B'">
                <b>
                    <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                </b>
            </ng-container>

            <ng-container *ngSwitchCase="'U'">
                <u>
                    <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                </u>
            </ng-container>

            <ng-container *ngSwitchCase="'I'">
                <i>
                    <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                </i>
            </ng-container>

            <ng-container *ngSwitchCase="'STRIKE'">
                <s>
                    <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                </s>
            </ng-container>

            <ng-container *ngSwitchCase="'A'">
                <ng-container *ngIf="files$ | async as files">

                    <ng-container *ngIf="!node.file || !files[node.file]; else pointer">
                        <span>
                            <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                        </span>
                    </ng-container>

                    <ng-template #pointer>
                        <span mr-file-pointer [id]="node.file" [editorHost]="host">
                            <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
                        </span>
                    </ng-template>

                </ng-container>
            </ng-container>

            <ng-container *ngSwitchDefault>
                <ng-container [ngTemplateOutlet]="el" [ngTemplateOutletContext]="{ node: node }"></ng-container>
            </ng-container>

        </ng-container>
    </ng-container>
</ng-template>

<ng-template #el let-node="node">

    <ng-container *ngIf="node.children; else text">

        <ng-container
        *ngFor="let n of node.children"
        [ngTemplateOutlet]="nodeSwitch"
        [ngTemplateOutletContext]="{ node: n }"></ng-container>

    </ng-container>

    <ng-template #text>
        {{ node.text }}
    </ng-template>

</ng-template>
